# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
import es, popuplib, playerlib, cmdlib, random
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func     = es.import_addon('sam/functions')
core     = es.import_addon('sam/core')
admins   = es.import_addon('sam/core/admins')
pcontrol = es.import_addon('sam/core/pcontrol')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x # VARIABLES/DICTIONARIES/LISTS # xx #
ids = {1:'spec',2:'t',3:'ct'}
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# CMDS
	func.SayCMD('!spec', specCMD)

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# CMDS
	func.unSayCMD('!spec')

	# POPUPS	
	func.popupDelete('teamChange')
	func.popupDelete('oppositeTeams')
	func.popupDelete('moveToSpectator')
	func.popupDelete('moveToTeams')

# =============================================================================== #
# === <<<> MAIN BLOCKS <>>> ===================================================== #
# =============================================================================== #
def page(ID, SEND=True):
	popup = func.simplemenu('teamChange','pcontrol')
	popup.addline(func.header(func.langPcontrol('TEAMS_MANAGER')))
	popup.addline(func.line)
	popup.addline('->1. %s' % func.stripColors(func.langCommon('SPEC')))
	popup.addline('->2. %s' % func.stripColors(func.langCommon('T')))
	popup.addline('->3. %s' % func.stripColors(func.langCommon('CT')))
	popup.addline('->4. %s' % func.langPcontrol('MOVE_OPPOSITE_TEAM'))
	popup.addline('->5. %s' % func.langPcontrol('MOVE_SWAP'))
	popup.addline('->6. %s' % func.langPcontrol('MOVE_SCRAMBLE'))
	popup.addline('->7. %s' % func.langPcontrol('MOVE_ALLSPEC'))
	popup.addline(' ')
	popup.addline(func.line)
	popup.addline('->0. %s' % func.langCommon('CANCEL'))
	popup.select(1, moveToSpectator)
	popup.select(2, moveToTeams)
	popup.select(3, moveToTeams)
	popup.select(4, oppositeTeams)
	popup.select(5, swapTeams)
	popup.select(6, scrambleTeams)
	popup.select(7, allSpec)
	if SEND: popup.send(ID)

# =============================================================================== #
# === <<<> FUNCTIONS <>>> ======================================================= #
# =============================================================================== #
def moveToSpectator(ID, OPTION, POPUP):
	teams = [ply for x in (playerlib.getPlayerList('#ct'),playerlib.getPlayerList('#t')) for ply in x]
	if (len(teams)) > 0:
		func.popupDelete('moveToSpectator')
		popup = func.easymenu(popuplib.easymenu('moveToSpectator', None, moveToSpectatorChoice),'teamChange')
		popup.settitle(func.header(func.langPcontrol('TEAMS_MANAGER')))
		popup.setdescription(' # %s' % func.langCommon('CHOOSE_PLAYER'))
		for x in teams: popup.addoption(x, '%s [%s]' % (x.name,ids[x.teamid].upper()))
		popup.send(ID)
	else:
		func.hudhint(ID, func.langCommon('NO_TEAMS'),func.teamstag)
		page(ID)

# ------------------------------------------------------------------------------- #
def moveToSpectatorChoice(ID, TARGET, POPUP):
	es.server.insertcmd('es_xchangeteam %s 1' % (TARGET))
	func.hudhint(TARGET, func.langPcontrol('TELL_TARGET_MOVED',{'team':func.langCommon('SPEC')}),func.teamstag)
	func.tell('#all', func.langPcontrol('TARGET_MOVED',{'target':TARGET.name,'team':func.langCommon('SPEC')}), func.teamstag)
	page(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def moveToTeams(ID, TEAM, POPUP):
	teams = [ply for x in (playerlib.getPlayerList('#spec'),playerlib.getPlayerList('#%s'%ids[TEAM])) for ply in x]
	a = {2:3,3:2}
	if (len(teams)) > 0:
		func.popupDelete('moveToTeams')
		popup = func.easymenu(popuplib.easymenu('moveToTeams', None, moveToTeamsChoice),'teamChange')
		popup.settitle(func.header(func.langPcontrol('TEAMS_MANAGER')))
		popup.setdescription(' # %s' % func.langCommon('CHOOSE_PLAYER'))
		for x in teams: popup.addoption([x,a[TEAM]], '%s [%s]' % (x.name,ids[x.teamid].upper()))
		popup.send(ID)
	else:
		func.hudhint(ID, func.langCommon('NO_TEAMS'),func.teamstag)
		page(ID)

# ------------------------------------------------------------------------------- #
def moveToTeamsChoice(ID, TOKEN, POPUP):
	es.server.insertcmd('es_xchangeteam %s %s' % (TOKEN[0],TOKEN[1]))
	func.hudhint(TOKEN[0], func.langPcontrol('TELL_TARGET_MOVED',{'team':func.langCommon(ids[TOKEN[1]].upper())}),func.teamstag)
	func.tell('#all', func.langPcontrol('TARGET_MOVED',{'target':TOKEN[0].name,'team':func.langCommon(ids[TOKEN[1]].upper())}), func.teamstag)
	moveToTeams(ID, TOKEN[1], None)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def oppositeTeams(ID, OPTION, POPUP):
	teams = [ply for x in (playerlib.getPlayerList('#ct'),playerlib.getPlayerList('#t')) for ply in x]
	if (len(teams)) > 0:
		func.popupDelete('oppositeTeams')
		popup = func.easymenu(popuplib.easymenu('oppositeTeams', None, oppositeTeamsChoice),'teamChange')
		popup.settitle(func.header(func.langPcontrol('TEAMS_MANAGER')))
		popup.setdescription(' # %s' % func.langCommon('CHOOSE_PLAYER'))
		for x in teams: popup.addoption(x, '%s [%s]' % (x.name,ids[x.teamid].upper()))
		popup.send(ID)
	else:
		func.hudhint(ID, func.langCommon('NO_TEAMS'),func.teamstag)
		page(ID)

# ------------------------------------------------------------------------------- #
def oppositeTeamsChoice(ID, TARGET, POPUP):
	if   TARGET.teamid == 2: team = 3
	elif TARGET.teamid == 3: team = 2
	es.server.insertcmd('es_xchangeteam %s %s' % (TARGET,team))
	func.hudhint(TARGET, func.langPcontrol('TELL_TARGET_MOVED',{'team':func.langCommon(ids[team].upper())}),func.teamstag)
	func.tell('#all', func.langPcontrol('TARGET_MOVED',{'target':TARGET.name,'team':func.langCommon(ids[team].upper())}), func.teamstag)
	oppositeTeams(ID, None, None)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def swapTeams(ID, OPTION, POPUP):
	teams = [ply for x in (playerlib.getPlayerList('#ct'),playerlib.getPlayerList('#t')) for ply in x]
	if (len(teams)) > 0:
		for x in teams:
			if not x.steamid == 'BOT':
				if x.teamid == 2: es.server.insertcmd('es_xchangeteam %s 3' % x)
				if x.teamid == 3: es.server.insertcmd('es_xchangeteam %s 2' % x)
		es.server.insertcmd('bot_kick')
		es.server.insertcmd('bot_quota %s' % (int(es.ServerVar('bot_quota'))))
		func.tell('#all', func.langPcontrol('TEAMS_SWAPED'),func.teamstag)
	else:
		if ID: func.hudhint(ID, func.langCommon('NO_TEAMS'),func.teamstag)
	if ID: page(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def scrambleTeams(ID, OPTION, POPUP):
	es.server.insertcmd('bot_kick')
	humans = [ply for ply in playerlib.getPlayerList('#human')]
	for ply in humans: es.server.insertcmd('es_xchangeteam %s 1' % ply)
	teams = [[],[]]
	div   = int(len(humans) / 2)
	while len(teams[0]) <= div:
		for x in humans:
			teams[0].append(x)
			humans.remove(x)
		else:
			for x in humans: teams[1].append(x)
	a = random.choice([3,2])
	for x in teams[0]: es.server.insertcmd('es_xchangeteam %s %s' % (x,a))
	if a == 2: a = 3
	for x in teams[1]: es.server.insertcmd('es_xchangeteam %s %s' % (x,a))
	es.server.insertcmd('bot_quota %s' % (int(es.ServerVar('bot_quota'))))
	func.tell(ID, 'Scramble Teams', func.teamstag)
	page(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def allSpec(ID, OPTION, POPUP):
	teams = [ply for x in (playerlib.getPlayerList('#ct'),playerlib.getPlayerList('#t')) for ply in x]
	if (len(teams)) > 0:
		for x in teams: es.server.insertcmd('es_xchangeteam %s 1' % x)
		func.tell('#all', func.langPcontrol('ALLTOSPEC'),func.teamstag)
	else: func.hudhint(ID, func.langCommon('NO_TEAMS'),func.teamstag)
	page(ID)

# =============================================================================== #
# === <<<  CMD BLOCKS <    ====================================================== #
# =============================================================================== #
def specCMD(ID, ARGS):
	if not es.getplayerteam(ID) == 1:
		es.server.insertcmd('es_xchangeteam %s 1' % ID)
		func.hudhint(ID, func.langPcontrol('TELL_TARGET_MOVED',{'team':func.langCommon('SPEC')}),func.teamstag)

# =============================================================================== #