# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
from __future__ import with_statement
import es, playerlib, cmdlib, langlib, gamethread, usermsg, urllib2, time, re, os, random, popuplib
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxx # PATHS AND FILES # xxxxxxxx #
sampath     = es.getAddonPath('sam')
langPath    = sampath + '/langs/'
dbfolder    = 'sam_config/databases'
cfgPath     = 'cstrike/cfg/sam_config/'
addonscfg   = cfgPath + 'addons_cfg/'
cfgfile     = cfgPath + 'config.cfg'
reasonsfile = cfgPath + 'reasons.txt'
dlfile      = cfgPath + 'downloads.cfg'
dbPath      = cfgPath + 'databases/'
soundsPath  = 'cstrike/sound/sam_sounds/'
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
if not os.path.exists(addonscfg): os.makedirs(addonscfg)
if not os.path.exists(cfgPath + 'databases'): os.makedirs(cfgPath + 'databases')
if not os.path.exists(cfgPath + 'addons_cfg'): os.makedirs(cfgPath + 'addons_cfg')
if not os.path.exists(soundsPath): os.makedirs(soundsPath)
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x # VARIABLES/DICTIONARIES/LISTS # xx #
dev     = False
version = 'sam_version_full'
line    = '-' * 45
cloud   = {'title':'ADMIN MENU','tag':'S4M','tagcolor':'#red','trigger':'!sam','version':es.ServerVar('sam_version_full'),
		   'newversion':False,'popups':[],'timeout':30,'filters':[],'cmds':{}}
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxxxxx # TAGS # xxxxxxxxxxxxxx #
updatetag   = '#purpleUPDATE SYSTEM'
errortag    = '#redERROR'
adminstag   = '#cyanADMINS'
servertag   = '#yellowSERVER'
teamstag    = '#beigeTEAMS'
settingstag = 'SETTINGS SYSTEM'
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxx # COLOR DICTIONARY # xxxxxxx #
colors = {'#t':'FF3D3D','#ct':'9BCDFF','#spec':'CDCDCD','#default':'FFB300','#brown':'A52A2A','#pink':'FF69B4','#red':'FF0000',
          '#darkred':'8B0000','#orange':'FFA500','#yellow':'FFFF00','#gold':'FFD700','#green':'00FF00','#darkgreen':'458B00',
          '#lightgreen':'9BFF9B','#cyan':'00FFFF','#blue':'0000FF','#darkblue':'00008B','#purple':'9B30FF','#darkpurple':'551A8B',
          '#white':'FFFFFF','#grey':'808080','#lightgrey':'D3D3D3','#darkgrey':'A9A9A9','#black':'000000','#beige':'F5F5DC','#dimgreen':'9EC34F'}
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# TRIGGER AND CMD
	SayCMD(cloud['trigger'], triggerCMD)
	ClientCMD('sam_menu', triggerCMD)
	ServerCMD('sam_trigger_cmd', modTriggerCMD)

	# CMDS
	SayCMD('!rcon', rconCMD)
	SayCMD('!admins', adminsCMD)
	SayCMD('!rr', rrCMD)
	SayCMD('!rs', rsCMD)
	SayCMD('!unload', unloadCMD)
	SayCMD('!reload', reloadCMD)
	SayCMD('!teams', teamsCMD)
	ServerCMD('sam_title_cmd', titleCMD)
	ServerCMD('sam_tag_cmd', tagCMD)
	ServerCMD('sam_tagcolor_cmd', tagcolorCMD)

	# DOWNLOADS AND SETTINGS SYSTEMS
	dlFile()
	createFiles()

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# UNREGISTER CMDS
	unSayCMD('!rcon')
	unSayCMD('!admins')
	unSayCMD('!rr')
	unSayCMD('!rs')
	unSayCMD('!unload')
	unSayCMD('!reload')
	unSayCMD(cloud['trigger'])
	unSayCMD('!teams')
	unClientCMD('sam_menu')
	unServerCMD('sam_trigger_cmd')
	unServerCMD('sam_title_cmd')
	unServerCMD('sam_tag_cmd')
	unServerCMD('sam_tagcolor_cmd')

	# CANCEL DELAYS
	gamethread.cancelDelayed('sam_rs_delay')
	gamethread.cancelDelayed('sam_rs_loop')
	gamethread.cancelDelayed('sam_cmds_loop')

	# DELETE POPUPS CLOUD
	for popup in cloud['popups']:
		if popuplib.exists(popup): popuplib.delete(popup)

# =============================================================================== #
# === <<<> MESSAGE SYSTEM <>>> ================================================== #
# =============================================================================== #
def tell(users, text, tag=False, l=True):
	if tag: usermsg.saytext2(users, 0, takeColors('#default%s%s #grey| #black%s #grey| #default%s' % (cloud['tagcolor'],cloud['tag'], tag, text)))
	else: usermsg.saytext2(users, 0, takeColors('#default%s%s #grey| #default%s' % (cloud['tagcolor'],cloud['tag'], text)))
	if l: log(stripColors(text),stripColors(tag))

# ------------------------------------------------------------------------------- #
def say(users, text, l=False):
	usermsg.saytext2(users, 0, takeColors('#default%s' % text))
	if l: log(stripColors(text))

# ------------------------------------------------------------------------------- #
def hudhint(users, text, tag=False):
	if tag: usermsg.hudhint(users, stripColors('| %s |\n %s' % (tag,text)))
	else: usermsg.hudhint(users, stripColors('%s' % text))

# ------------------------------------------------------------------------------- #
def centermsg(users, text, l=False):
	usermsg.centermsg(users, text)
	if l: log(text,'CENTERMSG')

# ------------------------------------------------------------------------------- #
def keyhint(users, text): usermsg.keyhint(users, text)

# ------------------------------------------------------------------------------- #
def motd(users, title, url): usermsg.motd(users, 2, title, url)

# ------------------------------------------------------------------------------- #
def log(MSG, TAG=False):
	if TAG: print('[SAM] %s :: %s' % (stripColors(TAG),MSG))
	else: print('[SAM] %s' % MSG)

# =============================================================================== #
# === <<<> LANGUAGE SYSTEM <>>> ================================================= #
# =============================================================================== #
def langCore(name, tokens=None):
	langs = langlib.Strings(langPath + 'core.ini')
	return langs(name, tokens, 'en')

# ------------------------------------------------------------------------------- #
def langCommon(name, tokens=None):
	langs = langlib.Strings(langPath + 'common.ini')
	return langs(name, tokens, 'en')

# ------------------------------------------------------------------------------- #
def langAdmins(name, tokens=None):
	langs = langlib.Strings(langPath + 'admins.ini')
	return langs(name, tokens, 'en')

# ------------------------------------------------------------------------------- #
def langPcontrol(name, tokens=None):
	langs = langlib.Strings(langPath + 'pcontrol.ini')
	return langs(name, tokens, 'en')

# ------------------------------------------------------------------------------- #
def langAddon(addon, name, tokens=None):
	langs = langlib.Strings(langPath + '/addons/%s.ini' % addon)
	return langs(name, tokens, 'en')

# =============================================================================== #
# === <<<> DOWNLOADS SYSTEM <>>> ================================================ #
# =============================================================================== #
def dlFile():
	if os.path.isfile(dlfile): os.remove(dlfile)
	f = open(dlfile,'w')
	f.write('// - - - - - - - - - - - - - - - - - - - - - - -\n')
	f.write('//  Source Admin Menu # Downloads file\n')
	f.write('// - - - - - - - - - - - - - - - - - - - - - - -\n')
	f.write('//\n')
	f.write('//  Do not edit this file unless you are sure of what your doing!\n')
	f.write('//\n')
	f.write('// - - - - - - - - - - - - - - - - - - - - - - -\n \n')
	for x in [getSounds()]:
		for path in x: f.write('downloadable "%s"\n' % path.replace('cstrike/',''))
	f.close()
	es.server.insertcmd('exec sam_config/downloads.cfg')
	log('File refreshed.','DOWNLOADS SYSTEM')

# ------------------------------------------------------------------------------- #
def getSounds(): return [path+sound for path, dirs, files in os.walk(soundsPath) for sound in files if sound.endswith(('.mp3','.wav'))]

# =============================================================================== #
# === <<<> SETTINGS SYSTEM <>>> ================================================= #
# =============================================================================== #
def createFiles():
	if not os.path.isfile(cfgfile): # GLOBAL CONFIG FILE
		a = {'trigger':'Command to access the menu.','title':'Title for all the menus.',
			 'tag':'Your community/team/group tag.','tagcolor':'Color for you tag. EXP: red, blue, green, yellow, purple, etc.'}
		cfg = open(cfgfile,'w')
		cfg.write('// %s\n' % ('-' * 50))
		cfg.write('//  Source Admin Menu | Global Configuration File\n')
		cfg.write('// %s\n' % ('-' * 50))
		cfg.write('//  * Do not restart the server after changing any commands!\n')
		cfg.write('//  * Any changes will take effect within 10 seconds after you save this file.\n')
		cfg.write('// %s\n \n' % ('-' * 50))
		for x in a:
			cfg.write('// %s\n' % a[x])
			cfg.write('//\n')
			cfg.write('// Default: %s\n' % cloud[x].strip('#'))
			cfg.write('sam_%s_cmd %s\n \n' % (x,cloud[x].strip('#')))
		cfg.close()
		log('Global Configuration File created.',settingstag)
	if not os.path.isfile(reasonsfile): # REASONS FILE
		f = open(reasonsfile,'w')
		f.write('# - - - - - - - - - - - - - - - - - - #\n')
		f.write('#  Source Admin Menu # Reasons file   #\n')
		f.write('# - - - - - - - - - - - - - - - - - - #\n')
		f.write('#\n')
		f.write('#  These are the reasons for banning and kicking players.\n')
		f.write('#\n')
		f.write('# - - - - - - - - - - - - - - - - - - #\n')
		f.write(' \n')
		f.write('- Disrespecting admins\n')
		f.write('- Disrespecting Server rules\n')
		f.write('- Chat spaming / Micro noise\n')
		f.write('- Cheating with Aimbot\n')
		f.write('- Cheating with SpeedHack\n')
		f.write('- Cheating with wallhack')
		f.close()
		log('Reasons File created.',settingstag)
	gamethread.delayedname(1, 'sam_cmds_loop', execConfigs, (5))

# ------------------------------------------------------------------------------- #
def execConfigs(delay):
	cfglist = {}
	for item in os.listdir(addonscfg): cfglist[item] = addonscfg+item
	cfglist['config.cfg'] = cfgfile
	monitor = es.import_addon('sam/core/monitor')
	for x in cfglist:
		if x != 'config.cfg':
			if int(monitor.get(x.replace('.cfg',''),'status')) == 1:
				es.server.insertcmd('exec %s' % cfglist[x].replace('cstrike/cfg/',''))
		else: es.server.insertcmd('exec %s' % cfglist[x].replace('cstrike/cfg/',''))
	gamethread.delayedname(delay, 'sam_cmds_loop', execConfigs, (5))

# =============================================================================== #
# === <<<> UPDATE SYSTEM <>>> =================================================== #
# =============================================================================== #
def update(msg=False):
	if not dev:
		log('Checking for updates.',updatetag)
		try:
			url = urllib2.urlopen('http://www.skinngaming.com/sam/version.txt')
			cloud['newversion'] = str(url.read())
			url.close()
			if cloud['newversion'] == cloud['version']:
				cloud['newversion'] = False
				if msg: tell('#all', langCore('UPDATED', cloud), updatetag)
			elif msg: tell('#all', langCore('OUTDATED', cloud), updatetag)
		except:
			if msg: tell('#all', langCore('NO_CONNECTION'), updatetag)

# =============================================================================== #
# === <<<> FUNCTIONS <>>> ======================================================= #
# =============================================================================== #
def takeColors(text):
	for x in colors: text = text.replace(x,'\x07'+colors[x])
	return text

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def stripColors(MSG):
	if MSG:
		for x in colors: MSG = MSG.replace(x,'')
		return MSG

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def convert(steamid):
    x, y, z = str(steamid).split(':')
    return (int(z)*2) + 76561197960265728L + int(y)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def SayCMD(CMD, CALLBACK, DESC='SAM CMD'): cmdlib.registerSayCommand(CMD, CALLBACK, DESC)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def ClientCMD(CMD, CALLBACK, DESC='SAM CMD'): cmdlib.registerClientCommand(CMD, CALLBACK, DESC)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def ServerCMD(CMD, CALLBACK, DESC='SAM CMD'): cmdlib.registerServerCommand(CMD, CALLBACK, DESC)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def unSayCMD(CMD): cmdlib.unregisterSayCommand(CMD)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def unClientCMD(CMD): cmdlib.unregisterClientCommand(CMD)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def unServerCMD(CMD): cmdlib.unregisterServerCommand(CMD)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def sound(target, sound, volume, attenuation): es.emitsound('player', target, sound, volume, attenuation)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def play(target, sound): es.cexec_all(target,'play',sound)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def playall(sound): es.cexec_all('play',sound)

# xxx ### POPUPS ### xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxzxxxx #
def header(module=None):
	if module: return '%s | SAM %s\n \n :: %s ' % (cloud['title'],cloud['version'],module)
	else: return '%s | SAM %s\n \n:: ' % (cloud['title'],cloud['version'])

# ------------------------------------------------------------------------------- #
def popupDelete(name):
	if popuplib.exists(name): popuplib.delete(name)
	if not name in cloud['popups']: cloud['popups'].append(name)

# ------------------------------------------------------------------------------- #
def sendPage(index,x=7,p=1):
	while x <= index:
		x += 7
		p += 1
	else: return p

# ------------------------------------------------------------------------------- #
def easymenu(POPUP, SUBMENU=None,TIMEOUT=True):
	POPUP.c_beginsep = line
	POPUP.c_pagesep  = line
	if SUBMENU: POPUP.submenu(10, SUBMENU)
	if TIMEOUT: POPUP.timeout('view', cloud['timeout'])
	return POPUP

# ------------------------------------------------------------------------------- #
def simplemenu(NAME,SUBMENU=None,TIMEOUT=True):
	popupDelete(NAME)
	popup = popuplib.create(NAME)
	if SUBMENU: popup.submenu(10, SUBMENU)
	if TIMEOUT: popup.timeout('view', cloud['timeout'])
	return popup

# =============================================================================== #
# === <<<> CMD BLOCKS <>>> ====================================================== #
# =============================================================================== #
def modTriggerCMD(ARGS):
	if es.exists('saycommand', cloud['trigger']): unSayCMD(cloud['trigger'])
	args = ' '.join(ARGS)
	if not args.isdigit():
		cloud['trigger'] = args
		SayCMD(args, triggerCMD)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def triggerCMD(ID, ARGS):
	admins = es.import_addon('sam/core/admins')
	if admins.existsDB() and len(admins.listAdmins()) > 0:
		if admins.isAdmin(es.getplayersteamid(ID)) or dev:
			core = es.import_addon('sam/core')
			core.home(ID)
		else: hudhint(ID, langAdmins('NO_ACCESS'), adminstag)
	else: admins.noAdmins(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def adminsCMD(ID, ARGS):
	admins = es.import_addon('sam/core/admins')
	LIST   = [ply.name for ply in playerlib.getPlayerList('#all') if admins.isAdmin(ply.steamid)]
	if len(LIST) > 0: tell(ID, '#ct%s#default.' % '#default, #ct'.join(LIST),adminstag+' ONLINE')
	else: tell(ID, langCore('NOADMINS'), adminstag)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def rrCMD(ID, ARGS):
	admins = es.import_addon('sam/core/admins')
	if admins.can(ID,'Server Commands'):
		es.server.insertcmd('mp_restartgame 1')
		tell('#all',langCore('RR'),servertag)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def rsCMD(ID, ARGS, SEC=None):
	if not SEC:
		admins = es.import_addon('sam/core/admins')
		if admins.can(ID,'Server Commands') and admins.can(ID,'Server Restart'):
			rsCMD(None, None, 5)
			gamethread.delayedname(5,'sam_rs_delay',es.server.insertcmd,('_restart'))
	elif SEC > 0:
		hudhint('#all',langCore('RS',{'sec':SEC}),servertag)
		gamethread.delayedname(1,'sam_rs_loop',rsCMD,(None, None, SEC-1))

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def titleCMD(ARGS):
	if ARGS:
		args = str(' '.join(ARGS))
		if len(args) < 16: cloud['title'] = args.strip('"')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def tagCMD(ARGS):
	if ARGS:
		args = str(' '.join(ARGS))
		if len(args) < 6: cloud['tag'] = args

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def tagcolorCMD(ARGS):
	if ARGS:
		args = str(' '.join(ARGS))
		args = '#%s'%args.lower().replace('#','')
		if args in colors: cloud['tagcolor'] = args

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def unloadCMD(ID, ARGS):
	admins = es.import_addon('sam/core/admins')
	if admins.can(ID,'Server Commands'): es.unload('sam')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def reloadCMD(ID, ARGS):
	admins = es.import_addon('sam/core/admins')
	if admins.can(ID,'Server Commands'): es.reload('sam')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def rconCMD(ID, ARGS):
	admins = es.import_addon('sam/core/admins')
	if admins.can(ID,'Server RCON') and ARGS:
		cmd = ARGS[0]
		ARGS.remove(cmd)
		args = ' '.join(ARGS)
		if es.exists('variable', cmd) or es.exists('command', cmd):
			if ARGS:
				es.server.insertcmd('%s %s' % (cmd,args))
				for x in ('sam_','sv_','mp_','rate','cl_','rcon_'):
					if cmd.startswith(x): gamethread.delayed(.1, tell, ('#all', langCore('RCON_EXEC_CMD', {'cmd':cmd, 'args':args}), servertag))
				if cmd in ('es_load','es_unload','es_reload'): gamethread.delayed(.1, tell, ('#all', langCore('RCON_ES_CMD', {'cmd':cmd, 'args':args}), servertag))
			elif cmd.startswith('bot_'):
				es.server.insertcmd(cmd)
				gamethread.delayed(.1, tell, ('#all', langCore('RCON_EXEC_CMD_NOARGS', {'cmd':cmd}), servertag))
			else: hudhint(ID, langCore('RCON_NOARGS'),errortag)
		else: hudhint(ID, langCore('RCON_NOTACMD',{'cmd':cmd}),errortag)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def teamsCMD(ID, ARGS):
	admins   = es.import_addon('sam/core/admins')
	pcontrol = es.import_addon('sam/core/pcontrol')
	if admins.isAdmin(ID): pcontrol.listPlayers(ID, 'Manage Teams')

# =============================================================================== #
# === <<<> EVENTS <>>> ========================================================== #
# =============================================================================== #
def es_map_start(ev):
	dlFile() # DOWNLOADS
	update() # CHECK FOR VERSIONS
	for popup in cloud['popups']: # DELETE POPUPS FROM CLOUD
		if popuplib.exists(popup): popuplib.delete(popup)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def round_end(ev): update() # CHECK FOR VERSIONS

# =============================================================================== #